' This class is "generated" and will be overwritten.
' Your customizations should be made in RankRecord.vb

Imports System.Data.SqlTypes
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider

Namespace Persons.Business

''' <summary>
''' The generated superclass for the <see cref="RankRecord"></see> class.
''' </summary>
''' <remarks>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, 
''' use the methods of the <see cref="RankTable"></see> class.
''' </remarks>
''' <seealso cref="RankTable"></seealso>
''' <seealso cref="RankRecord"></seealso>

<Serializable()> Public Class BaseRankRecord
	Inherits PrimaryKeyRecord
	

	Public Shared Shadows ReadOnly TableUtils As RankTable = RankTable.Instance

	' Constructors
 
	Protected Sub New()
		MyBase.New(TableUtils)
	End Sub

	Protected Sub New(ByVal record As PrimaryKeyRecord)
		MyBase.New(record, TableUtils)
	End Sub
	
	'Evaluates Initialize when->Inserting record formulas specified at the data access layer
    Public Overridable Sub RankRecord_InsertingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.InsertingRecord
        'Apply Initialize->Inserting record formula only if validation is successful.
        	        Dim RankRec As RankRecord = CType(sender,RankRecord)
        Validate_Inserting()
        If Not RankRec Is Nothing AndAlso Not RankRec.IsReadOnly Then
                End If
    End Sub

	'Evaluates Initialize when->Updating record formulas specified at the data access layer
    Public Overridable Sub RankRecord_UpdatingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.UpdatingRecord
        'Apply Initialize->Updating record formula only if validation is successful.
        	        Dim RankRec As RankRecord = CType(sender,RankRecord)
        Validate_Updating()
        If Not RankRec Is Nothing AndAlso Not RankRec.IsReadOnly Then
                End If
    End Sub
    
    'Evaluates Initialize when->Reading record formulas specified at the data access layer
    Public Overridable Sub RankRecord_ReadRecord(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ReadRecord
        'Apply Initialize->Reading record formula only if validation is successful.
        	        Dim RankRec As RankRecord = CType(sender,RankRecord)
        If Not RankRec Is Nothing AndAlso Not RankRec.IsReadOnly Then
                End If
    End Sub
    
   'Evaluates Validate when->Inserting formulas specified at the data access layer
   Public Overridable Sub Validate_Inserting ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
	
	'Evaluates Validate when->Updating formulas specified at the data access layer
   Public Overridable Sub Validate_Updating ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
 
	Public Overridable Function EvaluateFormula(ByVal formula As String, Optional ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord = Nothing, Optional ByVal format As String = Nothing) As String

		Dim e As Data.BaseFormulaEvaluator = New Data.BaseFormulaEvaluator()

            ' All variables referred to in the formula are expected to be
            ' properties of the DataSource.  For example, referring to
            ' UnitPrice as a variable will refer to DataSource.UnitPrice
            e.DataSource = dataSourceForEvaluate

            Dim resultObj As Object = e.Evaluate(formula)
            If resultObj Is Nothing Then
                Return ""
            End If
        	Return resultObj.ToString()
	End Function







#Region "Convenience methods to get/set values of fields"

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.RankId field.
	''' </summary>
	Public Function GetRankIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.RankIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.RankId field.
	''' </summary>
	Public Function GetRankIdFieldValue() As Int32
		Return CType(Me.GetValue(TableUtils.RankIdColumn).ToInt32(), Int32)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.RankId field.
	''' </summary>
	Public Sub SetRankIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.RankIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.RankId field.
	''' </summary>
	Public Sub SetRankIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.RankIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.RankId field.
	''' </summary>
	Public Sub SetRankIdFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.RankId field.
	''' </summary>
	Public Sub SetRankIdFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.RankId field.
	''' </summary>
	Public Sub SetRankIdFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankIdColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.RankLevel field.
	''' </summary>
	Public Function GetRankLevelValue() As ColumnValue
		Return Me.GetValue(TableUtils.RankLevelColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.RankLevel field.
	''' </summary>
	Public Function GetRankLevelFieldValue() As Int32
		Return CType(Me.GetValue(TableUtils.RankLevelColumn).ToInt32(), Int32)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.RankLevel field.
	''' </summary>
	Public Sub SetRankLevelFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.RankLevelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.RankLevel field.
	''' </summary>
	Public Sub SetRankLevelFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.RankLevelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.RankLevel field.
	''' </summary>
	Public Sub SetRankLevelFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankLevelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.RankLevel field.
	''' </summary>
	Public Sub SetRankLevelFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankLevelColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.RankLevel field.
	''' </summary>
	Public Sub SetRankLevelFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankLevelColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.ArmyId field.
	''' </summary>
	Public Function GetArmyIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.ArmyIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.ArmyId field.
	''' </summary>
	Public Function GetArmyIdFieldValue() As Byte
		Return CType(Me.GetValue(TableUtils.ArmyIdColumn).ToByte(), Byte)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.ArmyId field.
	''' </summary>
	Public Sub SetArmyIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.ArmyIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.ArmyId field.
	''' </summary>
	Public Sub SetArmyIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.ArmyIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.ArmyId field.
	''' </summary>
	Public Sub SetArmyIdFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ArmyIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.ArmyId field.
	''' </summary>
	Public Sub SetArmyIdFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ArmyIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.ArmyId field.
	''' </summary>
	Public Sub SetArmyIdFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ArmyIdColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.ShortRank field.
	''' </summary>
	Public Function GetShortRankValue() As ColumnValue
		Return Me.GetValue(TableUtils.ShortRankColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.ShortRank field.
	''' </summary>
	Public Function GetShortRankFieldValue() As String
		Return CType(Me.GetValue(TableUtils.ShortRankColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.ShortRank field.
	''' </summary>
	Public Sub SetShortRankFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.ShortRankColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.ShortRank field.
	''' </summary>
	Public Sub SetShortRankFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ShortRankColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.ShortRankNormal field.
	''' </summary>
	Public Function GetShortRankNormalValue() As ColumnValue
		Return Me.GetValue(TableUtils.ShortRankNormalColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.ShortRankNormal field.
	''' </summary>
	Public Function GetShortRankNormalFieldValue() As String
		Return CType(Me.GetValue(TableUtils.ShortRankNormalColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.ShortRankNormal field.
	''' </summary>
	Public Sub SetShortRankNormalFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.ShortRankNormalColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.ShortRankNormal field.
	''' </summary>
	Public Sub SetShortRankNormalFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ShortRankNormalColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.EShortRank field.
	''' </summary>
	Public Function GetEShortRankValue() As ColumnValue
		Return Me.GetValue(TableUtils.EShortRankColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.EShortRank field.
	''' </summary>
	Public Function GetEShortRankFieldValue() As String
		Return CType(Me.GetValue(TableUtils.EShortRankColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.EShortRank field.
	''' </summary>
	Public Sub SetEShortRankFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.EShortRankColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.EShortRank field.
	''' </summary>
	Public Sub SetEShortRankFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.EShortRankColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.RankName field.
	''' </summary>
	Public Function GetRankNameValue() As ColumnValue
		Return Me.GetValue(TableUtils.RankNameColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.RankName field.
	''' </summary>
	Public Function GetRankNameFieldValue() As String
		Return CType(Me.GetValue(TableUtils.RankNameColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.RankName field.
	''' </summary>
	Public Sub SetRankNameFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.RankNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.RankName field.
	''' </summary>
	Public Sub SetRankNameFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.ERankName field.
	''' </summary>
	Public Function GetERankNameValue() As ColumnValue
		Return Me.GetValue(TableUtils.ERankNameColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.ERankName field.
	''' </summary>
	Public Function GetERankNameFieldValue() As String
		Return CType(Me.GetValue(TableUtils.ERankNameColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.ERankName field.
	''' </summary>
	Public Sub SetERankNameFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.ERankNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.ERankName field.
	''' </summary>
	Public Sub SetERankNameFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.ERankNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.RankLevelName field.
	''' </summary>
	Public Function GetRankLevelNameValue() As ColumnValue
		Return Me.GetValue(TableUtils.RankLevelNameColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.RankLevelName field.
	''' </summary>
	Public Function GetRankLevelNameFieldValue() As String
		Return CType(Me.GetValue(TableUtils.RankLevelNameColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.RankLevelName field.
	''' </summary>
	Public Sub SetRankLevelNameFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.RankLevelNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.RankLevelName field.
	''' </summary>
	Public Sub SetRankLevelNameFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankLevelNameColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.suffix field.
	''' </summary>
	Public Function GetsuffixValue() As ColumnValue
		Return Me.GetValue(TableUtils.suffixColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's Rank_.suffix field.
	''' </summary>
	Public Function GetsuffixFieldValue() As String
		Return CType(Me.GetValue(TableUtils.suffixColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.suffix field.
	''' </summary>
	Public Sub SetsuffixFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.suffixColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's Rank_.suffix field.
	''' </summary>
	Public Sub SetsuffixFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.suffixColumn)
	End Sub



#End Region

#Region "Convenience methods to get field names"

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Rank_.RankId field.
	''' </summary>
	Public Property RankId() As Int32
		Get 
			Return CType(Me.GetValue(TableUtils.RankIdColumn).ToInt32(), Int32)
		End Get
		Set (ByVal val As Int32) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.RankIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property RankIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.RankIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property RankIdDefault() As String
        Get
            Return TableUtils.RankIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Rank_.RankLevel field.
	''' </summary>
	Public Property RankLevel() As Int32
		Get 
			Return CType(Me.GetValue(TableUtils.RankLevelColumn).ToInt32(), Int32)
		End Get
		Set (ByVal val As Int32) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.RankLevelColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property RankLevelSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.RankLevelColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property RankLevelDefault() As String
        Get
            Return TableUtils.RankLevelColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Rank_.ArmyId field.
	''' </summary>
	Public Property ArmyId() As Byte
		Get 
			Return CType(Me.GetValue(TableUtils.ArmyIdColumn).ToByte(), Byte)
		End Get
		Set (ByVal val As Byte) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.ArmyIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property ArmyIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.ArmyIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property ArmyIdDefault() As String
        Get
            Return TableUtils.ArmyIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Rank_.ShortRank field.
	''' </summary>
	Public Property ShortRank() As String
		Get 
			Return CType(Me.GetValue(TableUtils.ShortRankColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.ShortRankColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property ShortRankSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.ShortRankColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property ShortRankDefault() As String
        Get
            Return TableUtils.ShortRankColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Rank_.ShortRankNormal field.
	''' </summary>
	Public Property ShortRankNormal() As String
		Get 
			Return CType(Me.GetValue(TableUtils.ShortRankNormalColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.ShortRankNormalColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property ShortRankNormalSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.ShortRankNormalColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property ShortRankNormalDefault() As String
        Get
            Return TableUtils.ShortRankNormalColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Rank_.EShortRank field.
	''' </summary>
	Public Property EShortRank() As String
		Get 
			Return CType(Me.GetValue(TableUtils.EShortRankColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.EShortRankColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property EShortRankSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.EShortRankColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property EShortRankDefault() As String
        Get
            Return TableUtils.EShortRankColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Rank_.RankName field.
	''' </summary>
	Public Property RankName() As String
		Get 
			Return CType(Me.GetValue(TableUtils.RankNameColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.RankNameColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property RankNameSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.RankNameColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property RankNameDefault() As String
        Get
            Return TableUtils.RankNameColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Rank_.ERankName field.
	''' </summary>
	Public Property ERankName() As String
		Get 
			Return CType(Me.GetValue(TableUtils.ERankNameColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.ERankNameColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property ERankNameSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.ERankNameColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property ERankNameDefault() As String
        Get
            Return TableUtils.ERankNameColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Rank_.RankLevelName field.
	''' </summary>
	Public Property RankLevelName() As String
		Get 
			Return CType(Me.GetValue(TableUtils.RankLevelNameColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.RankLevelNameColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property RankLevelNameSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.RankLevelNameColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property RankLevelNameDefault() As String
        Get
            Return TableUtils.RankLevelNameColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's Rank_.suffix field.
	''' </summary>
	Public Property suffix() As String
		Get 
			Return CType(Me.GetValue(TableUtils.suffixColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.suffixColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property suffixSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.suffixColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property suffixDefault() As String
        Get
            Return TableUtils.suffixColumn.DefaultValue
        End Get
    End Property



#End Region

End Class
End Namespace
